﻿Imports System
Imports System.ComponentModel
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Collections.Specialized

Namespace BestellungenEdm

   Partial Public Class Artikel


   End Class

   Partial Public Class BestellPosten

   End Class

   Partial Public Class Bestellung

   End Class
   Partial Public Class Kunde


   End Class

   Public Class BestellungenEdmContainer

      Public Function CreateRegisteredCollectionView(Of T As Class)(items As IEnumerable(Of T)) As ListCollectionView
         If NotifyPropertyChanged.IsInDesignMode Then Return New ListCollectionView(items.ToList)
         Dim oc = New ObservableCollection(Of T)(items)
         Dim cv As New ListCollectionView(oc)
         If Not TypeOf items Is IQueryable(Of T) Then
            Dim dbSet = Me.Set(Of T)()
            oc.ForEach(AddressOf dbSet.Add)
         End If
         RegisterCV(cv, True)
         Return cv
      End Function

      ''' <summary> cvChilds wird ersetzt, und die neue befüllt mit den Children von cvParent.CurrentItem</summary>
      Public Sub ExchangeChildCV(Of T As Class, TChild As Class)(cvParent As ListCollectionView, ByRef cvChilds As ListCollectionView, childGetter As Func(Of T, IList(Of TChild)))
         If cvChilds.NotNull Then
            RegisterCV(cvChilds, False)
            cvChilds = Nothing
         End If
         Dim itm = DirectCast(cvParent.CurrentItem, T)
         If itm.Null Then Return
         cvChilds = New ListCollectionView(DirectCast(childGetter(itm), System.Collections.IList))
         RegisterCV(cvChilds, True)
      End Sub

      Private Sub RegisterCV(cv As ICollectionView, value As Boolean)
         If value Then
            AddHandler cv.CollectionChanged, AddressOf CollectionChanged
         Else
            RemoveHandler cv.CollectionChanged, AddressOf CollectionChanged
         End If
      End Sub

      Private Sub CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
         Select Case e.Action
            Case NotifyCollectionChangedAction.Add
               Dim itm = e.NewItems(0)
               Dim tp = itm.GetType
               If Not tp.IsVisible Then Return
               Me.Set(tp).Add(itm)
            Case NotifyCollectionChangedAction.Remove
               Dim itm = e.OldItems(0)
               Dim tp = itm.GetType
               If Not tp.IsVisible Then Return
               Me.Set(tp).Remove(itm)
         End Select
      End Sub

   End Class


End Namespace