
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, 2012 and Azure
-- --------------------------------------------------
-- Date Created: 01/06/2018 15:24:54
-- Generated from EDMX file: C:\Programming\VS13\Wpf\Bestellungen\Bestellungen\Model\BestellungenEdm.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [Bestellungen];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ArtikelBestellPosten]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BestellPostenSet] DROP CONSTRAINT [FK_ArtikelBestellPosten];
GO
IF OBJECT_ID(N'[dbo].[FK_KundeBestellung]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BestellungSet] DROP CONSTRAINT [FK_KundeBestellung];
GO
IF OBJECT_ID(N'[dbo].[FK_BestellungBestellPosten]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BestellPostenSet] DROP CONSTRAINT [FK_BestellungBestellPosten];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[ArtikelSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ArtikelSet];
GO
IF OBJECT_ID(N'[dbo].[KundeSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[KundeSet];
GO
IF OBJECT_ID(N'[dbo].[BestellungSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[BestellungSet];
GO
IF OBJECT_ID(N'[dbo].[BestellPostenSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[BestellPostenSet];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'ArtikelSet'
CREATE TABLE [dbo].[ArtikelSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Preis] decimal(18,0)  NOT NULL
);
GO

-- Creating table 'KundeSet'
CREATE TABLE [dbo].[KundeSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'BestellungSet'
CREATE TABLE [dbo].[BestellungSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Datum] datetime  NOT NULL,
    [KundeId] int  NOT NULL
);
GO

-- Creating table 'BestellPostenSet'
CREATE TABLE [dbo].[BestellPostenSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Count] int  NOT NULL,
    [BestellungId] int  NOT NULL,
    [ArtikelId] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'ArtikelSet'
ALTER TABLE [dbo].[ArtikelSet]
ADD CONSTRAINT [PK_ArtikelSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'KundeSet'
ALTER TABLE [dbo].[KundeSet]
ADD CONSTRAINT [PK_KundeSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'BestellungSet'
ALTER TABLE [dbo].[BestellungSet]
ADD CONSTRAINT [PK_BestellungSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'BestellPostenSet'
ALTER TABLE [dbo].[BestellPostenSet]
ADD CONSTRAINT [PK_BestellPostenSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [ArtikelId] in table 'BestellPostenSet'
ALTER TABLE [dbo].[BestellPostenSet]
ADD CONSTRAINT [FK_ArtikelBestellPosten]
    FOREIGN KEY ([ArtikelId])
    REFERENCES [dbo].[ArtikelSet]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_ArtikelBestellPosten'
CREATE INDEX [IX_FK_ArtikelBestellPosten]
ON [dbo].[BestellPostenSet]
    ([ArtikelId]);
GO

-- Creating foreign key on [KundeId] in table 'BestellungSet'
ALTER TABLE [dbo].[BestellungSet]
ADD CONSTRAINT [FK_KundeBestellung]
    FOREIGN KEY ([KundeId])
    REFERENCES [dbo].[KundeSet]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_KundeBestellung'
CREATE INDEX [IX_FK_KundeBestellung]
ON [dbo].[BestellungSet]
    ([KundeId]);
GO

-- Creating foreign key on [BestellungId] in table 'BestellPostenSet'
ALTER TABLE [dbo].[BestellPostenSet]
ADD CONSTRAINT [FK_BestellungBestellPosten]
    FOREIGN KEY ([BestellungId])
    REFERENCES [dbo].[BestellungSet]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_BestellungBestellPosten'
CREATE INDEX [IX_FK_BestellungBestellPosten]
ON [dbo].[BestellPostenSet]
    ([BestellungId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------