﻿#Region "FileHeader"
#If False Then
überschreibt FindIndexByName(), und die Nodes werden sortiert eingefügt. Dann aber auch DeleteSaveChilds() überschreiben.
AllowRecurseMerge() ermöglicht Erben, individuelle Ausnahmen vom Mergen zu machen, und so doch zuzulassen, dass NamensDoubletten sich im selben Node finden - habe ich in einem Fall benötigt.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
#End Region 'FileHeader

Namespace System

   <DebuggerDisplay("{FullName}")> _
   Partial Public Class SortedNode(Of T As {SortedNode(Of T), New}) : Inherits Node(Of T)

      Private Shared _BinarySearcher As New BinarySearcher(Of T, String)(Function(nd) nd.Name)
      Public Overrides Function FindIndexByName(name As String) As Integer
         Return _BinarySearcher.Search(InnerList, name)
      End Function

      Public Overrides Sub DeleteSaveChilds()
         If Count > 0 Then
            Parent.InnerList.Remove(DirectCast(Me, T))
            DirectCast(Parent, T).MergeInsert(Me)
         Else
            Delete()
         End If
      End Sub
      Public Sub MergeInsert(others As ResetList(Of T))
         If Count = 0 Then
            AddRange(others)
            Return
         End If
         Dim il = InnerList
         For Each other In others
            Dim i = _BinarySearcher.Search(il, other.Name)
            If i >= 0 AndAlso Not AllowRecurseMerge(il(i)) Then i = Not i
            If i < 0 Then
               il.Insert(Not i, other)
               other.Parent = Me
            Else
               If other.Count > 0 Then il(i).MergeInsert(other)
            End If
         Next
         RaiseReset()
      End Sub
      Protected Overridable Function AllowRecurseMerge(nd As T) As Boolean
         Return True
      End Function

   End Class

End Namespace